<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import { Breadcrumb } from '../../interfaces';
import { createSchemaBreadcrumb } from '~/common/craftSchema';

export default Vue.extend({
  name: 'Breadcrumb',
  props: {
    crumbs: {
      type: Array as PropType<Breadcrumb[]>,
      required: true,
      default: () => [],
    },
  },
  data() {
    return {
      structuredData: {},
    };
  },
  head() {
    return {
      // Insert script for breadcrumb schema
      script: [
        {
          type: 'application/ld+json',
          json: this.structuredData,
        },
      ],
    };
  },
  beforeMount() {
    // Replace schema values with loaded crumbs
    this.structuredData = createSchemaBreadcrumb(this.$props.crumbs);
  },
});
</script>

<template>
  <span class="breadcrumb">
    <span
      v-for="(crumb, index) in crumbs"
      :key="index"
      class="breadcrumb__crumb"
      :class="{
        'breadcrumb__crumb--disabled': index === crumbs.length - 1,
        'hide-in-mobile': index !== crumbs.length - 2,
      }"
    >
      <template v-if="!crumb.hidden">
        <span
          v-if="index !== crumbs.length - 1"
          class="breadcrumb__chevron mobile-chevron"
        >
          <SlpIcon name="chevron-left" variant="product" size="xs" />
        </span>
        <a
          :href="crumb.href"
          :data-ga-name="crumb.data_ga_name"
          :data-ga-location="crumb.data_ga_location"
        >
          <SlpTypography tag="span" variant="body3">
            {{ crumb.title }}
          </SlpTypography>
        </a>
        <span
          v-if="index !== crumbs.length - 1"
          class="breadcrumb__chevron hide-in-mobile"
        >
          <SlpIcon name="chevron-right" variant="product" size="xs" />
        </span>
      </template>
    </span>
  </span>
</template>

<style scoped lang="scss">
.mobile-chevron {
  display: none;
  @media (max-width: $breakpoint-md) {
    display: block;
  }
}
.breadcrumb {
  display: flex;

  &__crumb {
    display: flex;
    color: $color-text-link-100;
    &:hover,
    &:focus,
    &:active {
      &:not(.breadcrumb__crumb--disabled) {
        text-decoration: underline;
      }
    }

    &--disabled {
      color: $color-text-200;
    }

    a {
      color: inherit;
    }
  }

  &__chevron {
    margin: 1px 10px 0 6px;
  }
}

.hide-in-mobile {
  @media (max-width: $breakpoint-md) {
    display: none;
  }
}
</style>
